/*
 * Copyright 2020 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package fr.gaellalire.vestige.jvm_enhancer.runtime;

import java.lang.ref.WeakReference;

/**
 * @author Gael Lalire
 */
public class LoaderHandlerLoaderKey {

    private WeakReference<ClassLoader> parent;

    private Object key;

    public LoaderHandlerLoaderKey(final ClassLoader parent, final Object key) {
        this.parent = new WeakReference<ClassLoader>(parent);
        this.key = key;
    }

    @Override
    public boolean equals(final Object obj) {
        if (!(obj instanceof LoaderHandlerLoaderKey)) {
            return false;
        }
        LoaderHandlerLoaderKey other = (LoaderHandlerLoaderKey) obj;
        if (parent.get() != other.parent.get()) {
            return false;
        }
        return key.equals(other.key);
    }

    @Override
    public int hashCode() {
        return key.hashCode();
    }

}
