/*
 * Copyright 2021 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package fr.gaellalire.vestige.jvm_enhancer.runtime;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

/**
 * @author Gael Lalire
 * @param <K> key type
 */
public class TrueMap<K> implements Map<K, Boolean> {

    @Override
    public int size() {
        return 0;
    }

    @Override
    public boolean isEmpty() {
        return false;
    }

    @Override
    public boolean containsKey(final Object key) {
        return false;
    }

    @Override
    public boolean containsValue(final Object value) {
        return false;
    }

    @Override
    public Boolean get(final Object key) {
        return Boolean.TRUE;
    }

    @Override
    public Boolean put(final K key, final Boolean value) {
        return Boolean.TRUE;
    }

    @Override
    public Boolean remove(final Object key) {
        return Boolean.TRUE;
    }

    @Override
    public void putAll(final Map<? extends K, ? extends Boolean> m) {
    }

    @Override
    public void clear() {
    }

    @Override
    public Set<K> keySet() {
        return null;
    }

    @Override
    public Collection<Boolean> values() {
        return null;
    }

    @Override
    public Set<Entry<K, Boolean>> entrySet() {
        return null;
    }

}
